#include "jpegdecoder.h"

JpegDecoder::JpegDecoder(ConcurrentQueue<Jpeg *, 64u> *queue, QObject *parent) :
    QObject(parent), m_queue(queue)
{
}

void JpegDecoder::operate()
{
    Jpeg *jpeg;
    forever {
        jpeg = m_queue->dequeue();
        QImage image;
        image.loadFromData(jpeg->data, "JPEG");
        emit finished(image, image.width(), image.height(), jpeg->index);
        delete jpeg;
    }
}
